{ 13.06.2002 Siro }

{ 1. WaveOutGetNumDevs und WaveOutGetDevCaps in eine Liste eintragen }
{ d.h. alle vorhandenen Gerte ermitteln. Ein TStringliste erstellen, }
{ die im Objectinspector verfgbar ist. Desgleichen mit allen WavIn Devices }
{ Auch das untersttzte Timeformat mglichst erfragen, ndert sich evtl wenn }
{ DeviceId gendert wird, also aktualisieren }



unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MMSystem, StdCtrls, ComCtrls, ExtCtrls;

const testCount:Integer=0;

  type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TrackBar1: TTrackBar;
    Label_Freq: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;


Type TWaveOutGetDataProc=procedure(pMem:pByte; var size:Integer);

Type TWaveOut = class(TComponent)
   private
   Handle       : HWaveOut;   { Handel wird bei WaveOutOpen gesetzte }
   DeviceId     : Integer;    { normalerweise WAVE_MAPPER, sollte aber gendert werden knnen }
   WaveFormatEx : TWaveFormatEx;  { Informationen des verwendeten Waveformats }
   MemSize      : Integer;    { Groesse eines Memorypuffers in Bytes }
   pWaveHdr1    : pWaveHdr;   { Wave Kopfinformation fr ersten  MemoryPuffer }
   pWaveHdr2    : pWaveHdr;   { Wave Kopfinformation fr zweiten MemoryPuffer }
   MemFlag      : Boolean;    { Flag welcher Puffer gerade gespielt wird }
   pMem1        : pByte;      { Speicher auf Playbuffer 1 }
   pMem2        : pByte;      { Speicher auf Playbuffer 2 }
   WomDoneWorking : Boolean;
   FWaveOutGetDataProc : TWaveOutGetDataProc;
   prepared : Boolean;
   Stopped  : Boolean;
  protected
    procedure UnPrepareAll;
    procedure SetSampleRate(NewSampleRate:Integer);
    procedure SetChannels(NewChannels:Word);
    procedure SetBitsPerSample(BitCount:Word);
    procedure SetMemBufferSize(NewSize:Integer);
    procedure SetWaveOutGetDataProc(proc:TWaveOutGetDataProc);
  public
   constructor create(AOwner:TComponent); override;
   destructor destroy; override;
   function PrepareAll:Boolean;
   procedure Start;
   procedure Stop;
  published
    property SampleRate : Integer read WaveFormatEx.nSamplesPerSec write SetSampleRate;
    property SampleBits : Word read WaveFormatEx.wBitsPerSample write SetBitsPerSample;
    property SampleChannels : Word read WaveFormatEx.nChannels write SetChannels;
{    property WaveOutGetDataProc : TWaveOutGetDataProc read FWaveOutGetDataProc write SetWaveOutGetDataProc; }
    property MemBufferSize : Integer read MemSize write SetMemBufferSize;
end;


Var WaveOut:TWaveOut;

implementation

{$R *.DFM}

{ so sieht die originale "C" Funktion laut Microsoft aus. }
{void CALLBACK waveOutProc(HWAVEOUT hwo, UINT uMsg, DWORD dwInstance,
      DWORD dwParam1, DWORD dwParam2); }

procedure WaveOutCallback(handle : HWaveOut; { the WaveOut handle }
                      uMsg     : UINT;       { the Message WOM_DONE, WOM_OPEN, WOM_CLOSE }
                      dwUser   : DWORD;      { das handle der Anwendung ???? oder des Fensters ??? }
                                             { kann beliebig benutzt werden, z.B Sender:TObject, gibt am meisten Sinn  }
                                             { oder ein Handle zu einem Thread, wird in WaveOutOpen festgelegt }
                      pHdr     : pWaveHdr;   { this is a pointer to the waveHeader which is ready with playing }
                      reserved : DWORD); stdcall; { do not use }
var pMem:pByte; size:Integer;
begin
  if handle <> WaveOut.Handle then begin { solle eigentlich nie passieren  }
    exit;              { lediglich wenn es mehrere WaveOuts gibt ???? }
                       { dann muesste jedoch jemand die CallbackRoutine erneut auf diese Routine gesetzt haben }
  end;                 { da kein anderer die Adresse meiner Routine kennt, kann das auch nicht passieren }

  with WaveOut do begin     { with TWaveOut(Sender) do begin     dwUser kann Sender sein  }
  case uMsg of
    WOM_DONE : begin       { ! bei CallBack Function WOM_DONE, bei WindowCallback MM_WOM_DONE }
                           { die Daten wurden abgespielt, der WaveHeader ist fertig }
                           { !! oder es wurde WaveOutReset aufgerufen, dann wird auch WM_DONE ausgelst }

                    if WomDoneWorking then begin    { Benutzer Routine noch nicht fertig geworden, System to slow }
                                                    { wir haben eine WOM_DONE innerhalb einer WOM_DONE bekommen }
                      exit;                         { irgendwelche Errors setzen ??? }
                    end else begin
                      WomDoneWorking:=TRUE;         { wir befinden uns nun in einer neue gestarteten WOM_DONE Funktion }
                      if Stopped then exit;         { keine neuen Daten vorbereiten wenn gestopped werden soll }
                      if NOT Assigned(FWaveOutGetDataProc) then exit;  { keine Benutzer Routine vorhanden, dann Ende  }

                      if MemFlag then pMem:=pMem2    { welcher der der beiden Memorybloecke ist gerade fertig ? }
                                 else pMem:=pMem1;   { dieser muss dann mit neuen Daten geladen werden }
                      MemFlag := NOT MemFlag;        { Merker, beim nchsten Durchlauf den anderen Block verwenden }

                      Size:=MemSize;                   { Standard Groesse des Speichers fr Wave Ausgabe setzen }
                      FWaveOutGetDataProc(pMem,size);  { Benutzer Routine aufrufen mit gerader fertig gewordenem Memoryblock }
                                                       { Benutzer Routine muss, kann "Size" evtl. neu setzen, }

                      pHdr^.dwBufferLength := size;           { Header Size neu setzen }
                      pHdr^.lpData         := PChar(pMem);    { Adresse auf neu berechnete Audiodaten setzen }

                      waveOutWrite(Handle,pHdr,SizeOf(TWaveHdr)); { in die Wave Ausgabe Warteschlange }
                      WomDoneWorking:=FALSE;   { WOM_DONE wurde ausgefhrt }
                    end; { else }

                  end; { WOM_DONE }
  end;
  end;{ with WaveOut }
end;

constructor TWaveOut.create(AOwner:TComponent);
begin
  inherited create(AOwner);

  MemSize:=(44100*2*2)*4;        { 44100 Hz, 16 Bit(2 Byte), Stereo(2 Kanle), 4 Sekunden }
                                 { PlayBuffer Length, dieser Speicher wird doppelt angelegt }
                                 { Einer spielt whrend der andere aufgefllt wird }
                                 { die Blcke wechseln sich stndig ab }

  WaveFormatEx.wFormatTag      := WAVE_FORMAT_PCM;
  WaveFormatEx.nChannels       := 2;                  { Anzahl der Kanle 2 = Stereo }
  WaveFormatEx.nSamplesPerSec  := 44100;              { Samplerate }
  WaveFormatEx.nAvgBytesPerSec := 44100 * 2 * 2;      { nBlockAlign * Samplerate }
  WaveFormatEx.nBlockAlign     := 2 * 2;              { 2 Bytes pro Sample mal 2 Kanle }
  WaveFormatEx.wBitsPerSample  := 16;                 { 16 Bits pro Sample }
  WaveFormatEx.cbSize          := 0;        { Anzahl extra bentigter Speicherbytes = 0 }

  { WaveOutDeviceList:=TStringList.craete }
  { WaveOutGetNumDevs }
  { WaveOutGetDevCaps }

  DeviceID := WAVE_MAPPER;   { bzw. WaveOutDeviceList index }

  { WaveInputDeviceDialog  }
  { WaveOutputDeviceDialog }

end;

{ ! hier muss der Speicher auf gerade "nBlockAlign" gesetzt werden }
{ das heisst Memsize muss exact durch nBlockAlign teilbar sein }
procedure TWaveOut.SetMemBufferSize(NewSize:Integer);
begin
  if MemSize = Newsize then exit;
  UnprepareAll;

  Memsize:=NewSize;
  PrepareAll;
end;

procedure TWaveOut.SetSampleRate(NewSampleRate:Integer);
begin
  With WaveFormatEx do begin
    if NewsampleRate = nSamplesPerSec then exit;
    UnprepareAll;
    nSamplesPerSec := NewSampleRate;
    PrepareAll;
  end;
end;

function BytesPerSample(BitCount:Integer):Integer;
begin
  BytesPerSample:=(BitCount+7) DIV 8;
end;

procedure TWaveOut.SetChannels(NewChannels:Word);
begin
  With WaveFormatEx do begin
    UnprepareAll;
    if NewChannels = nChannels then exit;
    nChannels       := NewChannels;
    nBlockAlign     := BytesPerSample(wBitsPerSample) * nChannels;
    nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;
    PrepareAll;
  end;
end;

procedure TWaveOut.SetBitsPerSample(BitCount:Word);
begin
  With WaveFormatEx do begin
    if wBitsPerSample = BitCount then exit;
    UnprepareAll;
    wBitsPerSample  := BitCount;
    nBlockAlign     := BytesPerSample(wBitsPerSample) * nChannels;
    nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;
    PrepareAll;
  end;
end;

procedure TWaveOut.SetWaveOutGetDataProc(proc:TWaveOutGetDataProc);
begin
  if @proc = @FWaveOutGetDataProc then exit;
  UnprepareAll;
  FWaveOutGetDataProc :=proc;
  PrepareAll;
end;

function TWaveOut.PrepareAll:Boolean;
var r:MMresult;  size:Integer;
var UserInstance:DWORD; { beliebig, wird spter an die Callback Funktion mit bergeben }
begin
  result:=FALSE;
  UnPrepareAll;
  UserInstance:=DWORD(self);  { eigene ObjektAdresse }
                                { dann knnte dwHInstance in der Callback Funktion TObject sein ???? }
  r:=waveOutOpen(@Handle,DeviceId,@waveFormatEx,DWORD(@WaveOutCallback),UserInstance,CALLBACK_FUNCTION);
  if r <> MMSYSERR_NOERROR then exit;
  result:=TRUE;
  WaveOutPause(Handle);

  GetMem(pMem1,MemSize);       { Sample Speicher 1 reservieren }
  if pMem1 <> NIL then FillChar(pMem1^,MemSize,0);  { Sample Speicher 1 subern }

  GetMem(pMem2,MemSize);       { Sample Speicher 2 reservieren }
  if pMem2 <> NIL then FillChar(pMem2^,MemSize,0);  { Sample Speicher 2 subern }

  GetMem(pWaveHdr1,SizeOf(TWaveHdr));            { Speicher fr Wave Header 1 reserviern }
  pWaveHdr1^.lpData          := pChar(pMem1);    { Struktur initialisieren }
  pWaveHdr1^.dwBufferLength  := MemSize;
  pWaveHdr1^.dwBytesRecorded := 0;
  pWaveHdr1^.dwUser          := 0;
  pWaveHdr1^.dwFlags         := 0;
  pWaveHdr1^.dwLoops         := 0;
  pWaveHdr1^.lpNext          := NIL;
  pWaveHdr1^.reserved        := 0;

  GetMem(pWaveHdr2,SizeOf(TWaveHdr));            { Speicher fr Wave Header 2 reserviern }
  Move(pWaveHdr1^,pWaveHdr2^,SizeOf(TWaveHdr));  { exakte Kopie vom WaveHeader 1 }
  pWaveHdr2^.lpData:=pChar(pMem2);               { bis auf den Datenspeicher }

  { Benutzer muss der ersten Sample Speicher fllen }
  size:=MemSize;
  if Assigned(FWaveOutGetDataProc) then FWaveOutGetDataProc(pMem1,size);

  { Benutzer muss den zweiten Sample Speicher fllen }
  size:=MemSize;
  if Assigned(FWaveOutGetDataProc) then FWaveOutGetDataProc(pMem2,size);

  WaveOutPrepareHeader(Handle,pWaveHdr1,SizeOf(TWaveHdr));
  WaveOutPrepareHeader(Handle,pWaveHdr2,SizeOf(TWaveHdr));

  Prepared:=TRUE;
end;

procedure TWaveOut.UnprepareAll;
begin
  if NOT Prepared then exit;
  if Handle = 0 then exit;

  { stop the playback, all queued Playback Headers are marked "Done" }
  Stopped:=TRUE;
  WaveOutReset(Handle);

  if pWaveHdr1 <> NIL then begin
    if pWaveHdr1^.dwFlags AND WHDR_INQUEUE > 0 then  { if currently used for playback }
      while pWaveHdr1^.dwFlags AND WHDR_DONE > 0 do;    { wait until done, normalerweise nicht ntig  }
    WaveOutUnprepareHeader(Handle,pWaveHdr1,SizeOf(TWaveHdr));
    FreeMem(pWaveHdr1,SizeOf(TWaveHdr));
  end;
  if pWaveHdr2 <> NIL then begin
    if pWaveHdr2^.dwFlags AND WHDR_INQUEUE > 0 then
      while pWaveHdr2^.dwFlags AND WHDR_DONE > 0 do;
    WaveOutUnprepareHeader(Handle,pWaveHdr2,SizeOf(TWaveHdr));
    FreeMem(pWaveHdr2,SizeOf(TWaveHdr));
  end;

  if pMem1 <> NIL then FreeMem(pMem1,MemSize);
  if pMem2 <> NIL then FreeMem(pMem2,MemSize);

  WaveOutClose(Handle);
{  WaveOutHandle:=0; }
  Prepared:=FALSE;
end;

procedure TWaveOut.Start;
begin
  if NOT Prepared then begin
    if NOT PrepareAll then begin

    end;
  end;
  waveOutWrite(Handle,pWaveHdr1,SizeOf(TWaveHdr));
  waveOutWrite(Handle,pWaveHdr2,SizeOf(TWaveHdr));
  Stopped:=FALSE;
  waveOutRestart(Handle);
end;

procedure TWaveOut.Stop;
begin
  Stopped:=TRUE;
  waveOutPause(Handle);
end;

destructor  TWaveOut.destroy;
begin
  UnprepareAll;
  { WaveOutDeviceList.free }
  inherited;
end;


{ hier brauche ich noch die Struktur WaveFormatEX }
{ damit ich weis wie die Samples abgelegt sind }
{ und wie der pointer incrementiert werden muss }
{ oder ich nehmen die FilterRoutine direkt in die komponente TWaveOut mit auf }
procedure Filter1(pMem:pByte; size:Integer);
var i:Integer;
begin
  for i:=1 to size do begin

  end;
end;

{ hier werden die Sample Daten erzeugt }
procedure MyDataProc(pMem:pByte; var size:Integer);
var i:Integer;
begin
  for i:=1 to size do begin
    pMem^:=random(255);   { den geamten Speicher mit zufallswerten auffuellen }
    inc(pMem);
  end;
end;

function Sinus(n:Extended):Extended;

  { Die "Sin" Funktion von Delphi liefert den Sinus in   }
  { Bogenmass(RAD). Diese Routine liefert den Wert in Altgrad(DEG) }

  begin
  Sinus:=sin(n*pi/180);
end;

const Winkel:Single=0;
const Frequenz:Single=1000;
procedure MyDataProcSinus(pMem:pByte; var size:Integer);
var i:Integer;  SamplesPerPeriode,WinkelPerSample,Winkel:Single; value:SmallInt;
begin
   { ! bei tiefen frequenzen muss Memsize mindestens eine periode gross sein, oder ??????}
  SamplesPerPeriode:=WaveOut.Samplerate / Frequenz;
  WinkelPerSample:=360 / SamplesPerPeriode;

  for i:=1 to size div 4 do begin
    value:=Round(Sinus(Winkel)*32766);
    pSmallInt(pMem)^:=Round(value);
    inc(pMem,2);
    pSmallInt(pMem)^:=Round(value);
    Winkel:=Winkel+WinkelPerSample;
    if Winkel > 360 then Winkel:=Winkel-360;
    inc(pMem,2);
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  WaveOut:=TWaveOut.create(self);
{  WaveOut.FWaveOutGetDataProc:=MyDataProc; }
  WaveOut.FWaveOutGetDataProc:=MyDataProcSinus;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  WaveOut.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  WaveOut.Start;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  WaveOut.Stop;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Frequenz:=TrackBar1.position;
  Label_Freq.caption:=FloatTostr(Frequenz);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  WaveOut.FWaveOutGetDataProc:=MyDataProc;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  WaveOut.FWaveOutGetDataProc:=MyDataProcSinus;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var t:TMMTime;
begin
  t.wType:= TIME_SAMPLES;
  WaveOutGetPosition(WaveOut.Handle,@t,SizeOf(t));
   { check that the Timeforamt is supported }
  {  if t.wType <> TIME_SAMPLES , not supported }
  caption:=IntTostr(t.sample);
end;

end.



